// CheckBoxList.java
//   
package com.porty.swing;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class CheckBoxList extends JList {
	//   
	public CheckBoxList(ListModel model) {
		super(model);
		initList();
	}
	public CheckBoxList(Object[] data) {
		super(data);
		initList();
	}
	public CheckBoxList(java.util.Vector data) {
		super(data);
		initList();
	}
	//   
	private void initList() {
		setCellRenderer(new CheckBoxCellRenderer());
		setSelectionMode(
			ListSelectionModel.SINGLE_SELECTION);
		addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
			//   
			if ( e.getClickCount() == 1 &&
			SwingUtilities.isLeftMouseButton(e) ) {
					//   
					int pos = 
					  locationToIndex(e.getPoint());
					CheckBoxListElement cbel =
						(CheckBoxListElement)getModel().
							getElementAt(pos);
					cbel.selected = ! cbel.selected;
					repaint();
				}
			}
		});
	}
	//   
	public static class CheckBoxCellRenderer 
		 extends JCheckBox implements ListCellRenderer {
		public Component getListCellRendererComponent(
			JList list, Object data, int idx,
				boolean isSelected, boolean hasFocus) {
			// ,     
			CheckBoxListElement 
				cbel = (CheckBoxListElement)data;
			//  
			if ( isSelected ) {
				setBackground(list.getSelectionBackground());
				setForeground(list.getSelectionForeground());
			} else {
				setBackground(list.getBackground());
				setForeground(list.getForeground());
			}
			setSelected(cbel.selected);
			setText(cbel.text);
			return this;
		}
	}
}